unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,OggDataLib, OggPlayerLib, OggWuvorbisLib, StdCtrls, ddsd, ComCtrls, ExtCtrls,
  mmsystem, DGCarad9;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Button5: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    ScrollBar2: TScrollBar;
    Label6: TLabel;
    Label7: TLabel;
    ScrollBar3: TScrollBar;
    ScrollBar4: TScrollBar;
    Label9: TLabel;
    ScrollBar5: TScrollBar;
    Button11: TButton;
    Button12: TButton;
    Image1: TImage;
    Button13: TButton;
    Button14: TButton;
    Image2: TImage;
    Image3: TImage;
    Label11: TLabel;
    Label12: TLabel;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Button26: TButton;
    Button27: TButton;
    Button28: TButton;
    Label8: TLabel;
    Label10: TLabel;
    Label13: TLabel;
    Button29: TButton;
    Button30: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    DDSD1: TDDSD;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure ScrollBar4Change(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure ScrollBar5Change(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Button26Click(Sender: TObject);
    procedure Button25Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure Button24Click(Sender: TObject);
    procedure Button27Click(Sender: TObject);
    procedure Button28Click(Sender: TObject);
    procedure Button29Click(Sender: TObject);
    procedure Button30Click(Sender: TObject);
  private
    { Private 錾 }
    FScrollBarLock : Boolean;
    FOnIdleLock   : Boolean;
  public
    { Public 錾 }
    OggPlayer : TOggPlayer;
    OggData1  : TOggData;
    OggData2  : TOggData;

    graph1,graph2,graph3 : array[0..255] of Single;

    wav:TDDSDWaveData;
    procedure UpdateWav(Sender:TDDSDGenWave; Player:TDDSDChannel; ofs,len:Cardinal);
    procedure IdleEvent(sender:TObject; var done:Boolean);
end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  Len : Integer;
begin
  chdir(ExtractFilePath(Application.ExeName));
  //DLLǂݍŁAOgggp\ɂB
  _VorbisfileInitialize('wuvorbis.dll');

  // obt@
  Len := 1024*64;

  // Oggf[^ĐPlayerClass
  // gčĐ邱
  // iOggf[^łĐł邯ǂˁj
  OggPlayer := TOggPlayer.Create(Len);

  // OggDataClassB
  // Đt@Cɓǂݍ܂āAOggPlayerɓo^Ă
  OggData1  := TOggData.Create(Len);
  OggData2  := TOggData.Create(Len);

  // Xg[~OĐ
  // ڂDDDDwvQƂ̂
  // K 44100Hz 16Bit STEREO łȂƃ_[II
  wav:=TDDSDWaveData.CreateStream(DDSD1, 44100, 16, TRUE, Len);
  wav.OnUpdate:=UpdateWav;
  DDSD1[0].WaveData:=wav;
  DDSD1[0].LoopPlay;

  Application.OnIdle := IdleEvent;

  TimeBeginPeriod(1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Application.OnIdle := nil;
  
  // Xg[~OTEh̉
  DDSD1[0].Stop;
  DDSD1[0].WaveData := nil;
  if (Wav <> nil)then Wav.Free;

  // Ogg֘A
  if (OggData1  <> nil)then OggData1.Free;
  if (OggData2  <> nil)then OggData2.Free;
  if (OggPlayer <> nil)then OggPlayer.Free;

  // DLL̉
  _VorbisfileFinalize;

  TimeEndPeriod(1);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // Oggt@CI
  if (Opendialog1.Execute = FALSE)then exit;
  // OggDataɃt@Cǂݍ܂
  OggData1.LoadOgg(Opendialog1.Filename);
  // OggPlayerɓo^
  OggPlayer.Load(0,OggData1);
  OggPlayer.Play(0,TRUE);

  //ȏĂ`
  //Q[ł͂܂gȂ񂾂ǂEEE
  //A{Ȃ񂩉ł(T T
  Memo1.Lines.Add(OggData1.Vendor);
  Memo1.Lines.AddStrings(OggData1.UserComment);
  Memo1.Lines.Add('Channels:'+IntToStr(OggData1.Channels));
  Memo1.Lines.Add('Rate:'+IntToStr(OggData1.Rate));
  Memo1.Lines.Add('TotalTime:'+FloatToStr(OggData1.TotalTime));
  Memo1.Lines.Add('TotalSize:'+IntToStr(OggData1.TotalSize));

  //V[No[̍őlȂ̒(Time(sec))ɐݒ
  ScrollBar1.Max := Round(OggData1.TotalTime);
end;

procedure TForm1.UpdateWav(Sender: TDDSDGenWave; Player: TDDSDChannel; ofs,
  len: Cardinal);
begin
  //OggPlayerɃ_O߂𔭌
  //ƁAقǓo^OggDataSĂ𓝍ďo͂
  OggPlayer.Rendering;
  //Ƃ́AXg[~OTEhɃ_Oʂ]
  wav.BlockCopy(ofs,OggPlayer.Offset,len);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  // Tbɉ1.0ɐݒitF[hCłȁj
  OggPlayer.SetVolume(0, 1.0, 5.0);
  // Đ߂𔭌ĂƃCC
  OggPlayer.Play(0,TRUE);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  // Tbɉ0.0ɐݒitF[hAEgj
  // ʂ0.0ɂȂƁAIɍĐ~
  OggPlayer.SetVolume(0, 0.0, 5.0);
  // Đ߂𔭌ĂƃCC
  OggPlayer.Play(0,TRUE);
end;


procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  // ScrollBarCxgbNĂ炳Ȃ
  if (FScrollBarLock)then exit;
  // OnIdelCxgbN
  FOnIdleLock := TRUE;
  // V[N
  OggPlayer.TimeSeek(0,ScrollBar1.Position);
  // ܂V[NR}hÂ킢̂ŁA҂
  Sleep(50);
  // OnIdelCxg̃bN
  FOnIdleLock := FALSE;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  // Đ
  OggPlayer.SetVolume(0,1.0);
  OggPlayer.Play(0,TRUE);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  // ~
  OggPlayer.Stop(0);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  // Oggt@CI
  if (Opendialog1.Execute = FALSE)then exit;
  // OggDataɃt@Cǂݍ܂
  OggData2.LoadOgg(Opendialog1.Filename);
  // OggPlayerɓo^
  OggPlayer.Load(1,OggData2);
  OggPlayer.Play(1,TRUE);

  //ȏĂ`
  //Q[ł͂܂gȂ񂾂ǂEEE
  //A{Ȃ񂩉ł(T T
  Memo1.Lines.Add(OggData2.Vendor);
  Memo1.Lines.AddStrings(OggData2.UserComment);
  Memo1.Lines.Add('Channels:'+IntToStr(OggData2.Channels));
  Memo1.Lines.Add('Rate:'+IntToStr(OggData2.Rate));
  Memo1.Lines.Add('TotalTime:'+FloatToStr(OggData2.TotalTime));
  Memo1.Lines.Add('TotalSize:'+IntToStr(OggData2.TotalSize));

  //V[No[̍őlȂ̒(Time(sec))ɐݒ
  ScrollBar2.Max := Round(OggData2.TotalTime);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  // Đ
  OggPlayer.SetVolume(1,1.0);  
  OggPlayer.Play(1,TRUE);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  // ~
  OggPlayer.Stop(1);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  // Tbɉ1.0ɐݒitF[hCłȁj
  OggPlayer.SetVolume(1, 1.0, 5.0);
  // Đ߂𔭌ĂƃCC
  OggPlayer.Play(1,TRUE);
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  // Tbɉ0.0ɐݒitF[hAEgj
  // ʂ0.0ɂȂƁAIɍĐ~
  OggPlayer.SetVolume(1, 0.0, 5.0);
  // Đ߂𔭌ĂƃCC
  OggPlayer.Play(1,TRUE);
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  // ScrollBarCxgbNĂ炳Ȃ
  if (FScrollBarLock)then exit;
  // OnIdleCxg̃bN
  FOnIdleLock := TRUE;
  // V[N
  OggPlayer.TimeSeek(1,ScrollBar2.Position);
  // ܂V[NR}hÂ킢̂ŁA҂
  Sleep(150);
  // OnIdleCxg̃bN
  FOnIdleLock := FALSE;
end;

procedure TForm1.ScrollBar3Change(Sender: TObject);
begin
  //`l̃}X^[{[ݒiɂ̓tF[h̊TO͂Ȃj
  OggPlayer.SetChannelVolume(0,ScrollBar3.Position/100);
end;

procedure TForm1.ScrollBar4Change(Sender: TObject);
begin
  //`l̃}X^[{[ݒiɂ̓tF[h̊TO͂Ȃj
  OggPlayer.SetChannelVolume(1,ScrollBar4.Position/100);
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  //S`lĐ
  OggPlayer.SetVolume(0,1.0);
  OggPlayer.SetVolume(1,1.0);
  OggPlayer.Play(TRUE);
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  //S`l~
  OggPlayer.Stop;
end;

procedure TForm1.ScrollBar5Change(Sender: TObject);
begin
  //S`l̃{[ݒ
  OggPlayer.SetMasterVolume(ScrollBar5.Position/100);
end;

procedure TForm1.IdleEvent(sender: TObject; var done: Boolean);
var
  i : Integer;
begin
  // FOnIdlebNĂꍇ͔
  if (FOnIdleLock)then exit;

  // ScrollBarCxgbN
  FScrollBarLock := TRUE;

  //ݍĐ̌oߎԂԂ
  Edit1.Text := format('%.2f sec',[OggPlayer.GetOutputTime(0)]);
  Edit2.Text := format('%.2f sec',[OggPlayer.GetOutputTime(1)]);

  // vOXo[ɃA^CLeftARight̉ʂ𔽉f
  ProgressBar1.Position := Round(OggPlayer.GetMasterOutputSum(0)*100);
  ProgressBar2.Position := Round(OggPlayer.GetMasterOutputSum(1)*100);

  // ݂̍ĐԂ\EV[No[ɔf
  ScrollBar1.Position := Round(OggPlayer.TimeTell(0));
  ScrollBar2.Position := Round(OggPlayer.TimeTell(1));

  //EQ&Graph\
  OggPlayer.GetoutputGraph(0,@graph1);
  with Image2.Canvas do
  begin
    Brush.Color := $02000000;
    FillRect(rect(0,0,64,48));
    //EQ
    for i:=0 to 61 do
    begin
      Brush.Color := $02FF00BB + i*$400;
      FillRect(rect(i+1,48,i+2,48-Round(OggPlayer.GetNowEQ(0,i*4)*24)));
    end;
    //Graph
    Brush.Color := $02FF00FF;
    for i:=0 to 61 do
      FillRect(rect(i+1,48,i+2,48-Round(graph1[i*4]*48)));
  end;

  OggPlayer.GetoutputGraph(1,@graph2);
  with Image3.Canvas do
  begin
    Brush.Color := $02000000;
    FillRect(rect(0,0,64,48));
    //EQ
    for i:=0 to 61 do
    begin
      Brush.Color := $02FF00BB + i*$400;
      FillRect(rect(i+1,48,i+2,48-Round(OggPlayer.GetNowEQ(1,i*4)*24)));
    end;
    //Graph
    Brush.Color := $02FF00FF;
    for i:=0 to 61 do
      FillRect(rect(i+1,48,i+2,48-Round(graph2[i*4]*48)));
  end;

  //MasterGraph\
  OggPlayer.GetMasterOutputGraph(@graph3);
  with Image1.Canvas do
  begin
    Brush.Color := $02000000;
    FillRect(rect(0,0,256,64));
    for i:=1 to 7 do
    begin
      Brush.Color := $02FF00BB + i*$100*32;
      FillRect(rect(i*32,0,i*32+1,48));
    end;
    for i:=0 to 253 do        //g`\
    begin
      Brush.Color := $02FF00FF + i*$100;
      FillRect(rect(i+1,48,i+2,48-Round(graph3[i]*48)));
    end;
  end;

  // ScrollBarCxgbN
  FScrollBarLock := FALSE;

  //点
  Sleep(10);
  
  Done := FALSE;
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  // LowPass
  OggPlayer.SetEQ4(0, 1,0,0,0, 5.0);
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  // HighPass
  OggPlayer.SetEQ4(0, 0,0,1,0, 5.0);
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  // LowReso
  OggPlayer.SetEQ4(0, 2,1,1,1, 5.0);
end;

procedure TForm1.Button16Click(Sender: TObject);
begin
  // HighReso
  OggPlayer.SetEQ4(0, 1,1,2,1, 5.0);
end;

procedure TForm1.Button17Click(Sender: TObject);
begin
  // Normal
  OggPlayer.SetEQ4(0, 1,1,1,1, 5.0);
end;

procedure TForm1.Button19Click(Sender: TObject);
begin
  // MiddleReso
  OggPlayer.SetEQ4(0, 1,2,1,1, 5.0);
end;

procedure TForm1.Button20Click(Sender: TObject);
begin
  // Wave
  OggPlayer.SetEQ8(0, 1.5,0.5,1.5,0.5,1.5,0.5,1.5,0.5, 5.0);    //݂ɂ
end;

procedure TForm1.Button18Click(Sender: TObject);
begin
  // LowHigh Pass
  OggPlayer.SetEQ4(0, 1.0,0.0,1.0,0.0, 5.0);
end;

procedure TForm1.Button21Click(Sender: TObject);
begin
  // LowPass
  OggPlayer.SetEQ4(1, 1,0,0,0, 5.0);
end;

procedure TForm1.Button22Click(Sender: TObject);
begin
  // HighPass
  OggPlayer.SetEQ4(1, 0,0,1,0, 5.0);
end;

procedure TForm1.Button26Click(Sender: TObject);
begin
  // LowHigh Pass
  OggPlayer.SetEQ4(1, 1.0,0.0,1.0,0.0, 5.0);
end;

procedure TForm1.Button25Click(Sender: TObject);
begin
  // Normal
  OggPlayer.SetEQ4(1, 1,1,1,1, 5.0);
end;

procedure TForm1.Button23Click(Sender: TObject);
begin
  // LowReso
  OggPlayer.SetEQ4(1, 2,1,1,1, 5.0);
end;

procedure TForm1.Button24Click(Sender: TObject);
begin
  // HighReso
  OggPlayer.SetEQ4(1, 1,1,2,1, 5.0);
end;

procedure TForm1.Button27Click(Sender: TObject);
begin
  // MiddleReso
  OggPlayer.SetEQ4(1, 1,2,1,1, 5.0);
end;

procedure TForm1.Button28Click(Sender: TObject);
begin
  // Wave
  OggPlayer.SetEQ8(1, 1.5,0.5,1.5,0.5,1.5,0.5,1.5,0.5, 5.0);    //݂ɂ
end;

procedure TForm1.Button29Click(Sender: TObject);
begin
  OggPlayer.Pause(0);
end;

procedure TForm1.Button30Click(Sender: TObject);
begin
  OggPlayer.Pause(1);
end;

end.
